from xpcom import components, ServerException, COMException, nsError
from xpcom._xpcom import PROXY_SYNC, PROXY_ALWAYS, PROXY_ASYNC
import os, sys
import threading
import logging

class PrefException(Exception):
    def __init__(self, prefid, msg):
        self.prefid = prefid
        self.msg = msg
        Exception.__init__(self)

def checkFileExists(prefset, pref, msg_if_empty = None):
    fname = prefset.getStringPref(pref)
    if msg_if_empty and not fname:
        raise PrefException(pref, msg_if_empty)
    if not os.path.isfile(fname):
        message = "File '%s' does not exist" % fname
        raise PrefException(pref, message)

def environmentStringsToDict(existing):
    ret = {}
    for i in range(len(existing)):
        try:
            key, value = existing[i].split("=", 1)
            ret[key] = value;
        except ValueError:
            log.debug("error on value " + repr(existing[i]))
            pass
    return ret

def environmentDictToStrings(env_dict):
    return ["%s=%s"  % (item[0], item[1]) for item in env_dict.items()]

